#!/usr/bin/env python

#****************************************************************************
# httpload.py, provides a plugin to open TreeLine files from the web
#
# TreeLine, an information storage program
# Copyright (C) 2004, Douglas W. Bell
#
# This is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License, Version 2.  This program is
# distributed in the hope that it will be useful, but WITTHOUT ANY WARRANTY.
#*****************************************************************************

"""httpLoad - opens TreeLine files from the web, v.0.1.1"""

import urllib2
from qt import *


class HttpLoad:
    """Class for loading http files"""
    def __init__(self, interface):
        self.interface = interface
        self.interface.getPulldownMenu(0).insertItem('Open from &web...', \
                                                     self.getAddress, 0, -1, 2)

    def getAddress(self):
        """Prompt user for web address"""
        addr, ok = QInputDialog.getText('TreeLine', 'Enter web address', \
                                        QLineEdit.Normal, '', \
                                        self.interface.mainWin)
        if ok:
            addr = unicode(addr)
            if ':' not in addr:
                addr = 'http://' + addr
            try:
                sock = urllib2.urlopen(addr)
                sock.name = addr.encode('utf-8')
                self.interface.openFile(sock, 1, 0)
            except IOError:
                QMessageBox.warning(self.interface.mainWin, 'TreeLine', \
                                    'Could not open %s' % addr)

def main(interface):
    """Main connection"""
    return HttpLoad(interface)
